/*       ___   ___   ___   ___
 *      /_  \ /   \ /  _\ /  _\
 *     // \_/// \_/_\ / \\  / \\
 *    //  _ //  _ / \\\_// /  //
 *    \\_/ \\\_/ \\ //  /  \_//
 *     \___/ \___/ \\__/ \___/
 *     Transferts srie pour Thomson
 *
 *  Oprations clavier RAW pour Windows
 *
 *  Copyright (C) 2015 Franois Mouret
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <stdio.h>
#include <conio.h>
#include <windows.h>

/*
 * Le programme rcupre une frappe RAW au clavier
 */
char GetKeyboardHit(void)
{
    char c = '\0' ;

    fflush(stdin) ;
    fflush(stdout) ;
    c = getch() ;

    /* Flushe les buffers pour Windows 95/98
     * Code inspir d'un source de GNAT COMPILER COMPONENTS
     * http://acapulco.dyndns.org/manual/src/work/gcc-4.3.0/gcc/ada/sysdep.c
     * Ce code permet la correction d'un 'bug' sur les
     * premires versions de Windows o le fflush(stdin)
     * n'a aucun effet */
    if (GetVersion() >= 0x80000000)
        FlushConsoleInputBuffer(GetStdHandle(STD_INPUT_HANDLE));

    /* Flushe les buffers de toutes les faons */
    while (kbhit ()) getch ();
    fflush(stdin) ;
    fflush(stdout) ;

    /* Renvoie le caractre lu */
    return c ;
}


